commit de41e8413182a93fa67eeea98bed9c30380ed4ca
Author: freddy77 <freddy77>
Date:   Mon Dec 7 16:22:12 2009 +0000

    Ported test for conversion from '' text to SQL_C_BINARY, remove possible core

diff --git a/ChangeLog b/ChangeLog
index 7b57db4..6699551 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Mon Dec  7 17:22:05 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/unittests/getdata.c src/tds/convert.c:
+	- Ported test for conversion from '' text to SQL_C_BINARY, remove
+	  possible core
+
 Sat Dec  5 14:43:00 EST 2009	JK Lowden <jklowden@freetds.org>
 	* src/apps/tsql.c applied small optind patch from ML
 
@@ -1957,4 +1962,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2899 2009/12/05 20:25:31 jklowden Exp $
+$Id: ChangeLog,v 1.2900 2009/12/07 16:22:12 freddy77 Exp $
diff --git a/src/odbc/unittests/getdata.c b/src/odbc/unittests/getdata.c
index 0617b13..36c6019 100644
--- a/src/odbc/unittests/getdata.c
+++ b/src/odbc/unittests/getdata.c
@@ -1,7 +1,7 @@
 #include "common.h"
 #include <assert.h>
 
-static char software_version[] = "$Id: getdata.c,v 1.13 2009/12/04 10:35:06 freddy77 Exp $";
+static char software_version[] = "$Id: getdata.c,v 1.14 2009/12/07 16:22:12 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static char odbc_err[256];
@@ -249,6 +249,20 @@ main(int argc, char *argv[])
 			lc = sizeof(SQLWCHAR);
 			type = SQL_C_WCHAR;
 		}	
+
+		Command("SELECT CONVERT(TEXT,'')");
+
+		CHKFetch("S");
+
+		len = 1234;
+		CHKGetData(1, SQL_C_BINARY, buf, 1, &len, "S");
+
+		if (len != 0) {
+			fprintf(stderr, "Wrong len returned, returned %ld\n", (long) len);
+			return 1;
+		}
+
+		CHKGetData(1, SQL_C_BINARY, buf, 1, NULL, "No");
 	}
 
 	Disconnect();
diff --git a/src/tds/convert.c b/src/tds/convert.c
index 0d1d44b..adc9967 100644
--- a/src/tds/convert.c
+++ b/src/tds/convert.c
@@ -64,7 +64,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: convert.c,v 1.193 2009/09/29 09:16:10 freddy77 Exp $");
+TDS_RCSID(var, "$Id: convert.c,v 1.194 2009/12/07 16:22:12 freddy77 Exp $");
 
 typedef unsigned short utf16_t;
 
@@ -351,7 +351,7 @@ tds_convert_char(int srctype, const TDS_CHAR * src, TDS_UINT srclen, int desttyp
 
 		/* skip leading "0x" or "0X" */
 
-		if (src[0] == '0' && (src[1] == 'x' || src[1] == 'X')) {
+		if (srclen >= 2 && src[0] == '0' && (src[1] == 'x' || src[1] == 'X')) {
 			src += 2;
 			srclen -= 2;
 		}

